require ('table')
require ('string')

-- string iterator

local nextchar = function (s, i)
    if i == nil then return 1, string.sub(s, 1, 1) end
    if i >= #s then return nil, nil end
    i = i + 1
    return i, string.sub(s, i, i)
end

-- string explist

chars = function (s)
    return nextchar, s, nil
end

-- full iteration

charlist = function (s)
    local result = {}
    for _, c in chars(s) do
        table.insert(result, c)
    end
    return result
end

digits = function (n)
    local L = charlist(tostring(n))
    table.sort(L)
    return table.concat(L)
end

local power = 100000
local i = power
repeat
    local dig = digits(i)
    local found = true
    for j = 6, 2, -1 do
        if dig ~= digits(j*i) then
            found = false
            break
        end
    end
    if found then
        print(i, 2*i, 3*i, 4*i, 5*i, 6*i)
        break
    end
    i = i+1
    if string.sub(tostring(i), 1, 1) == '2' then
        power = power * 10
        i = power
    end
until eternity

-- 142857   285714   428571   571428   714285   857142
